Index: src/sas/sasgui/perspectives/fitting/report_dialog.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/report_dialog.py	(revision 7432acb919f4013119ca918a73350297e0d4c93f)
+++ src/sas/sasgui/perspectives/fitting/report_dialog.py	(revision 69a68979fe94b8f135a602e7f02b162e34616d53)
@@ -38,22 +38,5 @@
         # number of images of plot
         self.nimages = len(self.report_list[2])
-
-        if self.report_list[2] is not None:
-            # put image path in the report string
-            if len(self.report_list[2]) == 1:
-                self.report_html = self.report_list[0] % \
-                                    "memory:img_fit0.png"
-            elif len(self.report_list[2]) == 2:
-                self.report_html = self.report_list[0] % \
-                                    ("memory:img_fit0.png",
-                                     "memory:img_fit1.png")
-            # allows up to three images
-            else:
-                self.report_html = self.report_list[0] % \
-                                    ("memory:img_fit0.png",
-                                     "memory:img_fit1.png",
-                                     "memory:img_fit2.png")
-        else:
-            self.report_html = self.report_list[0]
+        self.report_html = self.report_list[0]
         # layout
         self._setup_layout()
@@ -74,100 +57,58 @@
 
         fName = dlg.GetPath()
+        basename = os.path.splitext(fName)[0]
         ext_num = dlg.GetFilterIndex()
+        dlg.Destroy()
+
+        if ext_num == 0 and self.index_offset == 0:  # has pdf
+            ext = ".pdf"
+        elif ext_num == 1 - self.index_offset:
+            ext = ".html"
+        elif ext_num == 2 - self.index_offset:
+            ext = ".txt"
+        else:
+            logger.warn("unknown export format in report dialog")
+            return
+        filename = basename + ext
+
+        # save figures
+        pictures = []
+        for num in range(self.nimages):
+            pic_name = basename + '_img%s.png' % num
+            # save the image for use with pdf writer
+            self.report_list[2][num].savefig(pic_name)
+            pictures.append(pic_name)
+
+        # translate png references int html from in-memory name to on-disk name
+        html = self.report_html.replace("memory:img_fit", basename+'_img')
 
         #set file extensions
         img_ext = []
-        pic_fname = []
-        #PDF
-        if ext_num == (0 + 2 * self.index_offset):
-            # TODO: Sort this case out
-            ext = '.pdf'
+        if ext == ".pdf":
+            # write pdf as a pdf file
+            pdf = self.HTML2PDF(data=html, filename=filename)
 
-            fName = os.path.splitext(fName)[0] + ext
-            dlg.Destroy()
-            #pic (png) file path/name
-            for num in range(self.nimages):
-                im_ext = '_img%s.png' % num
-                #img_ext.append(im_ext)
-                pic_name = os.path.splitext(fName)[0] + im_ext
-                pic_fname.append(pic_name)
-                # save the image for use with pdf writer
-                self.report_list[2][num].savefig(pic_name)
+            # delete images used to create the pdf
+            for pic_name in pictures:
+                os.remove(pic_name)
 
-            #put the image path in html string
-            report_frame = self.report_list[0]
-            #put image name strings into the html file
-            #Note:The str for pic_fname shouldn't be removed.
-            if self.nimages == 1:
-                html = report_frame % str(pic_fname[0])
-            elif self.nimages == 2:
-                html = report_frame % (str(pic_fname[0]), str(pic_fname[1]))
-            elif self.nimages == 3:
-                html = report_frame % (str(pic_fname[0]), str(pic_fname[1]),
-                                          str(pic_fname[2]))
-
-            # make/open file in case of absence
-            f = open(fName, 'w')
-            f.close()
-            # write pdf as a pdf file
-            pdf = self.HTML2PDF(data=html, filename=fName)
-
-            #open pdf
+            #open pdf viewer
             if pdf:
                 try:
-                    #Windows
-                    os.startfile(str(fName))
-                except:
-                    try:
-                        #Mac
+                    if os.name == 'nt':  # Windows
+                        os.startfile(fName)
+                    elif sys.platform == "darwin":  # Mac
                         os.system("open %s" % fName)
-                    except:
-                        #DO not open
-                        pass
-            #delete image file
-            for num in range(self.nimages):
-                os.remove(pic_fname[num])
-            return
-        #HTML + png(graph)
-        elif ext_num == (1 - self.index_offset):
-            ext = '.html'
-            for num in range(self.nimages):
-                img_ext.append('_img4html%s.png' % num)
-            report_frame = self.report_list[0]
-        #TEXT + pdf(graph)
-        elif ext_num == (2 - self.index_offset):
-            ext = '.txt'
-            # changing the image extension actually changes the image
-            # format on saving
-            for num in range(self.nimages):
-                img_ext.append('_img4txt%s.pdf' % num)
-            report = self.report_list[1]
-        else:
-            return
+                except Exception as exc:
+                    # cannot open pdf
+                    logging.error(str(exc))
 
-        #file name
-        fName = os.path.splitext(fName)[0] + ext
-        dlg.Destroy()
+        elif ext == ".html":
+            with open(filename, 'w') as f:
+                f.write(html)
 
-        #pic (png) file path/name
-        for num in range(self.nimages):
-            pic_name = os.path.splitext(fName)[0] + img_ext[num]
-            pic_fname.append(pic_name)
-        #put the image path in html string
-        if ext_num == (1 - self.index_offset):
-            if self.nimages == 1:
-                report = report_frame % os.path.basename(pic_fname[0])
-            elif self.nimages == 2:
-                report = report_frame % (os.path.basename(pic_fname[0]),
-                                         os.path.basename(pic_fname[1]))
-            elif self.nimages == 3:
-                report = report_frame % (os.path.basename(pic_fname[0]),
-                                         os.path.basename(pic_fname[1]),
-                                         os.path.basename(pic_fname[2]))
-        f = open(fName, 'w')
-        f.write(report)
-        f.close()
+        elif ext == ".txt":
+            with open(filename, 'w') as f:
+                f.write(self.report_list[1])
+
         self.Update()
-        #save png file using pic_fname
-        for num in range(self.nimages):
-            self.report_list[2][num].savefig(pic_fname[num])
Index: src/sas/sasgui/perspectives/fitting/simfitpage.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/simfitpage.py	(revision f73b47cd2a0a7689c4369b24fd8891a9063b98fb)
+++ src/sas/sasgui/perspectives/fitting/simfitpage.py	(revision 24d9e84d007438874423eff4087eeb96df86663d)
@@ -2,7 +2,7 @@
     Simultaneous or Batch fit page
 """
-# Note that this is used for both Simultaneous/Constrained fit AND for 
+# Note that this is used for both Simultaneous/Constrained fit AND for
 # combined batch fit.  This is done through setting of the batch_on parameter.
-# There are the a half dozen or so places where an if statement is used as in 
+# There are the a half dozen or so places where an if statement is used as in
 # if not batch_on:
 #     xxxx
@@ -11,5 +11,5 @@
 # This is just wrong but dont have time to fix this go. Proper approach would be
 # to strip all parts of the code that depend on batch_on and create the top
-# level class from which a contrained/simultaneous fit page and a combined 
+# level class from which a contrained/simultaneous fit page and a combined
 # batch page inherit.
 #
@@ -23,4 +23,5 @@
 from wx.lib.scrolledpanel import ScrolledPanel
 
+from sas.sascalc.fit.pagestate import SimFitPageState
 from sas.sasgui.guiframe.events import StatusEvent, PanelOnFocusEvent
 from sas.sasgui.guiframe.panel_base import PanelBase
@@ -60,5 +61,4 @@
 
     return fittable_param
-
 
 class SimultaneousFitPage(ScrolledPanel, PanelBase):
@@ -157,8 +157,73 @@
         return self.state
 
+    def load_from_save_state(self, sim_state):
+        """
+        Load in a simultaneous/constrained fit from a save state
+        :param fit: Fitpanel object
+        :return: None
+        """
+        init_map = {}
+        final_map = {}
+        # Process each model and associate old M# with new M#
+        i = 0
+        for model in self.model_list:
+            model_id = self._format_id(model[1].keys()[0])
+            for saved_model in sim_state.model_list:
+                save_id = saved_model.pop('name')
+                saved_model['name'] = save_id
+                save_id = self._format_id(save_id)
+                if save_id == model_id:
+                    model_map[saved_model.pop('fit_page_source')] = \
+                        model[3].name
+                    check = bool(saved_model.pop('checked'))
+                    self.model_list[i][0].SetValue(check)
+                    inter_id = str(i)*5
+                    init_map[saved_model.pop('fit_page_source')] = inter_id
+                    final_map[inter_id] = model[3].name
+                    check = bool(saved_model.pop('checked'))
+                    self.model_list[i][0].SetValue(check)
+                    break
+            i += 1
+
+        self.check_model_name(None)
+
+        if len(sim_state.constraints_list) > 0:
+            self.hide_constraint.SetValue(False)
+            self.show_constraint.SetValue(True)
+            self._display_constraint(None)
+
+        for index, item in enumerate(sim_state.constraints_list):
+            model_cbox = item.pop('model_cbox')
+            if model_cbox != "":
+                constraint_value = item.pop('constraint')
+                param = item.pop('param_cbox')
+                equality = item.pop('egal_txt')
+                for key, value in init_map.items():
+                    model_cbox = model_cbox.replace(key, value)
+                    constraint_value = constraint_value.replace(key, value)
+                for key, value in final_map.items():
+                    model_cbox = model_cbox.replace(key, value)
+                    constraint_value = constraint_value.replace(key, value)
+
+                self.constraints_list[index][0].SetValue(model_cbox)
+                self._on_select_model(None)
+                self.constraints_list[index][1].SetValue(param)
+                self.constraints_list[index][2].SetLabel(equality)
+                self.constraints_list[index][3].SetValue(constraint_value)
+                self._on_add_constraint(None)
+                self._manager.sim_page = self
+
+    def _format_id(self, original_id):
+        original_id = original_id.rstrip('1234567890.')
+        new_id_list = original_id.split()
+        new_id = ' '.join(new_id_list)
+        return new_id
+
+
+
     def draw_page(self):
         """
         Construct the Simultaneous/Constrained fit page. fills the first
-        region (sizer1) with the list of available fit page pairs of data 
+        region (sizer1) with the list of available fit page pairs of data
         and models.  Then fills sizer2 with the checkbox for adding
         constraints, and finally fills sizer3 with the fit button and
@@ -1043,87 +1108,2 @@
         cbox.Append(name, value)
     cbox.SetStringSelection(selected)
-
-
-class SimFitPageState:
-    """
-    State of the simultaneous fit page for saving purposes
-    """
-
-    def __init__(self):
-        # Sim Fit Page Number
-        self.fit_page_no = None
-        # Select all data
-        self.select_all = False
-        # Data sets sent to fit page
-        self.model_list = []
-        # Data sets to be fit
-        self.model_to_fit = []
-        # Number of constraints
-        self.no_constraint = 0
-        # Dictionary of constraints
-        self.constraint_dict = {}
-        # List of constraints
-        self.constraints_list = []
-
-    def load_from_save_state(self, fit):
-        """
-        Load in a simultaneous/constrained fit from a save state
-        :param fit: Fitpanel object
-        :return: None
-        """
-
-        init_map = {}
-        final_map = {}
-        if fit.fit_panel.sim_page is None:
-            fit.fit_panel.add_sim_page()
-        sim_page = fit.fit_panel.sim_page
-
-        # Process each model and associate old M# with new M#
-        i = 0
-        for model in sim_page.model_list:
-            model_id = self._format_id(model[1].keys()[0])
-            for saved_model in self.model_list:
-                save_id = saved_model.pop('name')
-                saved_model['name'] = save_id
-                save_id = self._format_id(save_id)
-                if save_id == model_id:
-                    inter_id = str(i) + str(i) + str(i) + str(i) + str(i)
-                    init_map[saved_model.pop('fit_page_source')] = inter_id
-                    final_map[inter_id] = model[3].name
-                    check = bool(saved_model.pop('checked'))
-                    sim_page.model_list[i][0].SetValue(check)
-                    break
-            i += 1
-        sim_page.check_model_name(None)
-
-        if len(self.constraints_list) > 0:
-            sim_page.hide_constraint.SetValue(False)
-            sim_page.show_constraint.SetValue(True)
-            sim_page._display_constraint(None)
-
-        for index, item in enumerate(self.constraints_list):
-            model_cbox = item.pop('model_cbox')
-            if model_cbox != "":
-                constraint_value = item.pop('constraint')
-                param = item.pop('param_cbox')
-                equality = item.pop('egal_txt')
-                for key, value in init_map.items():
-                    model_cbox = model_cbox.replace(key, value)
-                    constraint_value = constraint_value.replace(key, value)
-                for key, value in final_map.items():
-                    model_cbox = model_cbox.replace(key, value)
-                    constraint_value = constraint_value.replace(key, value)
-
-                sim_page.constraints_list[index][0].SetValue(model_cbox)
-                sim_page._on_select_model(None)
-                sim_page.constraints_list[index][1].SetValue(param)
-                sim_page.constraints_list[index][2].SetLabel(equality)
-                sim_page.constraints_list[index][3].SetValue(constraint_value)
-                sim_page._on_add_constraint(None)
-                sim_page._manager.sim_page = sim_page
-
-    def _format_id(self, original_id):
-        original_id = original_id.rstrip('1234567890.')
-        new_id_list = original_id.split()
-        new_id = ' '.join(new_id_list)
-        return new_id
